"use strict";

exports.__esModule = true;
exports.lock = lock;
var queue = {};

function getReleaseFn(key) {
  return function () {
    queue[key].shift();
    startNext(key);
  };
}

function startNext(key) {
  var _queue$key$, _queue$key;

  (_queue$key$ = (_queue$key = queue[key])[0]) == null ? void 0 : _queue$key$.call(_queue$key, getReleaseFn(key));
}

function lock(key) {
  if (key === void 0) {
    key = "";
  }

  if (queue[key] === undefined) {
    queue[key] = [];
  }

  return new Promise(function (next) {
    queue[key].push(next);

    if (queue[key].length === 1) {
      return startNext(key);
    }

    return undefined;
  });
}